#!/usr/bin/perl

#
# Windy Chat : windy.cgi - 2011/10/02
# Copyright(C) KentWeb
# http://www.kent-web.com/
#
# REBUILD()
#
#  Windy Chat v2.1 PLUS member & deny & admin 2016/12/05
#  Edited by Hamel(TRANSFORM) Since 2012
#  http://www.transformsite.com/
#

# W[錾
use strict;
use CGI::Carp qw(fatalsToBrowser);

# ݒt@CF
require "./init.cgi";
my %cf = set_init();

# f[^
my %in = parse_form();

# 
&deny_host;
if ($in{mode} eq 'regist') { &regist; }
if ($in{mode} eq 'into') { &chat_page; }
if ($in{mode} eq 'out') { &room_out; }
if ($in{mode} eq 'rank') { rank_list(); }
form_page();

#-----------------------------------------------------------
#  tH[
#-----------------------------------------------------------
sub form_page {
	# NbL[擾
	my ($ck_nam,$ck_eml,$ck_col) = get_cookie();
	$ck_col = $ck_col ne '' ? $ck_col : 0;

	my $colors;
	foreach (0 .. $#{$cf{colors}}) {
		my ($col,undef) = split(/,/, $cf{colors}->[$_]);
		if ($ck_col == $_) {
			$colors .= qq|<input type="radio" name="color" value="$_" checked>|;
		} else {
			$colors .= qq|<input type="radio" name="color" value="$_">|;
		}
		$colors .= qq|<span style="color:$col"></span>\n|;

		if ($_ == int(@{$cf{colors}}/2)-1) { $colors .= "<br>\n"; }
	}

	open(IN,"$cf{tmpldir}/form.html") or &error("open err: form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;
	$tmpl =~ s/!chat_cgi!/$cf{chat_cgi}/g;
	$tmpl =~ s/!admin_cgi!/$cf{admin_cgi}/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/windy.css|g;
	$tmpl =~ s/!colors!/$colors/g;
	$tmpl =~ s/!name!/$ck_nam/g;
	$tmpl =~ s/!email!/$ck_eml/g;
	$tmpl =~ s/<!-- ranking_begin -->.+<!-- ranking_end -->//s if ($cf{ranking});

	print "Content-type: text/html\n\n";
	footer($tmpl);
}

#-----------------------------------------------------------
#  `bg
#-----------------------------------------------------------
sub chat_page {
	if ($in{mode} eq 'into') { &regist('into'); }

	# OȂIP
	if ($in{name} eq "") { $in{name} = $ENV{REMOTE_ADDR}; }

	# ݎ
	my ($num,$member) = member();

	# Fv_E
	my $op_colors;
	foreach (0 .. $#{$cf{colors}}) {
		my (undef,$nam) = split(/,/, $cf{colors}->[$_]);
		if ($in{color} == $_) {
			$op_colors .= qq|<option value="$_" selected>$nam\n|;
		} else {
			$op_colors .= qq|<option value="$_">$nam\n|;
		}
	}

	open(IN,"$cf{tmpldir}/chat.html") or &error("open err: form.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!chat_cgi!/$cf{chat_cgi}/g;
	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/windy.css|g;
	$tmpl =~ s/!name!/$in{name}/g;
	$tmpl =~ s/!email!/$in{email}/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/<!-- op_colors -->/$op_colors/g;
	$tmpl =~ s/!num!/$num/g;
	$tmpl =~ s/!member!/$member/g;
	$tmpl =~ s/!enam!/&url_encode($in{name})/eg;
	$tmpl =~ s/<!-- ranking_begin -->.+<!-- ranking_end -->//s if ($cf{ranking});

	# ev[g
	my ($head,$loop1,$loop2,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- boundary -->(.+)<!-- loop_end -->(.+)/s
		? ($1,$2,$3,$4) : error("ev[gs");

	# wb_
	print "Content-type: text/html\n\n";
	print $head;

	# O
	my $i;
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	while (<IN>) {
		my ($date,$name,$com,$col,undef,$time) = split(/<>/);

		$i++;
		my $tmp = $i % 2 ? $loop1 : $loop2;
		$tmp =~ s|!log:name!|<span style="color:$col">$name</span>|g;
		$tmp =~ s|!log:com!|<span style="color:$col">$com</span>|g;
		$tmp =~ s|!log:date!|$date|g;
		$tmp =~ s|!log:col!|$col|g;
		print $tmp;
	}
	close(IN);

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  L
#-----------------------------------------------------------
sub regist {
	# 
	my $job = shift;

	# RgȂ̓[h
	&chat_page if (!$job && $in{comment} eq '');

	my ($nam,$com,$eml,$col);
	if ($job eq 'into') {
		&set_cookie($in{name},$in{email},$in{color});
		$nam = $cf{master_name};
		$com = "$in{name}$cf{msg_in}";
		$col = $cf{master_color};

	} elsif ($job eq 'out') {
		$nam = $cf{master_name};
		$com = "$in{name}$cf{msg_out}";
		$col = $cf{master_color};

	} else {
		$nam = $in{email} ? qq|<a href="mailto:$in{email}">$cf{pointer}</a> <b>$in{name}</b>| : "$cf{pointer} <b>$in{name}</b>";
		$com = $in{comment};
		$eml = $in{email};
		$col = (split(/,/, $cf{colors}->[$in{color}]))[0];

		# LO
		if ($cf{rankkey}) { ranking(); }

	}

	# 擾
	my ($sec,$min,$hour,$mday,$mon,$year) = (localtime(time))[0..5];
	my $date = sprintf("%04d/%02d/%02d-%02d:%02d:%02d",$year+1900,$mon+1,$mday,$hour,$min,$sec);
	my $time = get_time();

	# zXg
	my $host = get_host();

	my ($i,@log);
	open(DAT,"+< $cf{logfile}") or &error("open err: $cf{logfile}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		my ($date,$name,$com,$col,undef,$time) = split(/<>/);
		$i++;
		push(@log,$_);
		last if ($i >= $cf{maxlog}-1);
	}

	## clear Ɠ͂邱ƂŎ̋L폜
	if ($com eq 'clear'){
		my @temp;
		my $match;
		foreach (@log) {
			my ($hos) = (split(/<>/))[4];
			if ($host eq $hos) { $match = 1; }
			else { push(@temp,$_); }
		}
		if ($match) {
			@log = @temp;
			$com = "All Clear (^-^)v";
		}
	}

	unshift (@log,"$date<>$nam<>$com<>$col<>$host<>$time\n");
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);

	# L
	&chat_page if (!$job);
}

#-----------------------------------------------------------
#  N
#-----------------------------------------------------------
sub ranking {
	my $now = time;

	my ($flg,@log);
	open(DAT,"+< $cf{rankfile}") || &error("open err: $cf{rankfile}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		my ($name,$kaisu,$time) = split(/<>/);
		next if ($now - $time > $cf{limit}*24*60*60);

		if ($name eq $in{name}) {
			$flg++;
			$kaisu++;
			$_ = "$name<>$kaisu<>$now<>\n";
		}
		push(@log,$_);
	}
	if (!$flg) { unshift(@log,"$in{name}<>1<>$now<>\n"); }
	seek(DAT, 0, 0);
	print DAT @log;
	truncate(DAT, tell(DAT));
	close(DAT);
}

#-----------------------------------------------------------
#  LO
#-----------------------------------------------------------
sub rank_list {
	# Nt@Cǂݍ
	my (@sort,@data);
	open(IN,"$cf{rankfile}") || &error("open err: $cf{rankfile}");
	while(<IN>) {
		my ($name,$count) = split(/<>/);

		push(@sort,$count);
		push(@data,$_);
	}
	close(IN);

	# \[g
	@data = @data[sort {$sort[$b] <=> $sort[$a]} 0 .. $#sort];

	open(IN,"$cf{tmpldir}/rank.html") or &error("open err: rank.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!limit!/$cf{limit}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/windy.css|g;
	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;

	# ev[g
	my ($head,$loop,$foot);
	if ($tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- loop_end -->(.+)/s) {
		($head,$loop,$foot) = ($1,$2,$3);
	} else {
		&error("ev[gsł");
	}

	# ʕ\
	print "Content-type: text/html\n\n";
	print $head;

	my ($i,$b_c,$b_r);
	foreach (@data) {
		$i++;
		my ($name,$count) = split(/<>/);
		my $rank = $count == $b_c ? $b_r : $i;

		my $tmp = $loop;
		$tmp =~ s/!rank!/$rank/g;
		$tmp =~ s/!name!/$name/g;
		$tmp =~ s/!count!/$count/g;
		print $tmp;

		$b_r = $rank;
		$b_c = $count;
	}

	print $foot;
	exit;
}

#-----------------------------------------------------------
#  IPANZX
#-----------------------------------------------------------
sub deny_host {
	my $addr = $ENV{REMOTE_ADDR};
	my $flg;
	open(IN,"$cf{denyfile}") || &error("open err: $cf{denyfile}");
	while (<IN>) {
		chomp;
		next if (!$_);
		s/\*/\.\*/g;
		if ($addr =~ /$_/i) { $flg++; last; }
	}
	close(IN);

	&error('\󂠂܂񂪌݂pł܂') if ($flg);
}

#-----------------------------------------------------------
#  ގ
#-----------------------------------------------------------
sub room_out {
	regist('out');

	# ݎ
	my ($num,$member) = &member('out');

	open(IN,"$cf{tmpldir}/out.html") or &error("open err: out.html");
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/windy.css|g;
	$tmpl =~ s/!name!/$in{name}/g;
	$tmpl =~ s/!homepage!/$cf{homepage}/g;
	$tmpl =~ s/!num!/$num/g;
	$tmpl =~ s/!member!/$member/g;

	# ev[g
	my ($head,$loop1,$loop2,$foot) = $tmpl =~ /(.+)<!-- loop_begin -->(.+)<!-- boundary -->(.+)<!-- loop_end -->(.+)/s
		? ($1,$2,$3,$4) : error("ev[gs");

	# wb_
	print "Content-type: text/html\n\n";
	print $head;

	# O
	my $i;
	open(IN,"$cf{logfile}") or &error("open err: $cf{logfile}");
	while (<IN>) {
		my ($date,$name,$com,$col,undef,$time) = split(/<>/);

		$i++;
		my $tmp = $i % 2 ? $loop1 : $loop2;
		$tmp =~ s|!log:name!|<span style="color:$col">$name</span>|g;
		$tmp =~ s|!log:com!|<span style="color:$col">$com</span>|g;
		$tmp =~ s|!log:date!|$date|g;
		$tmp =~ s|!log:col!|$col|g;
		print $tmp;
	}
	close(IN);

	# tb^
	footer($foot);
}

#-----------------------------------------------------------
#  tH[fR[h
#-----------------------------------------------------------
sub parse_form {
	my ($buf,%in);
	if ($ENV{REQUEST_METHOD} eq "POST") {
		&error('󗝂ł܂') if ($ENV{CONTENT_LENGTH} > $cf{maxdata});
		read(STDIN, $buf, $ENV{CONTENT_LENGTH});
	} else {
		$buf = $ENV{QUERY_STRING};
	}
	foreach ( split(/&/, $buf) ) {
		my ($key,$val) = split(/=/);
		$val =~ tr/+/ /;
		$val =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2", $1)/eg;

		# svR[h
		$val =~ s/&/&amp;/g;
		$val =~ s/</&lt;/g;
		$val =~ s/>/&gt;/g;
		$val =~ s/"/&quot;/g;
		$val =~ s/'/&#39;/g;
		$val =~ s/[\r\n]//g;

		$in{$key} = $val;
	}
	return %in;
}

#-----------------------------------------------------------
#  tb^[
#-----------------------------------------------------------
sub footer {
	my $foot = shift;

	# 쌠\Li폜Eϋ֎~j
	my $copy = <<EOM;
<p style="margin-top:2em;text-align:center;font-family:verdana,helvetica,arial;font-size:11pt;">
- <a href="http://www.kent-web.com/" target="_top">$cf{version}</a> -<br>
++ <a href="http://www.transformsite.com/" target="_top">Edited by Hamel</a> ++
</p>
EOM

	if ($foot =~ /(.+)(<\/body[^>]*>.*)/si) {
		print "$1$copy$2\n";
	} else {
		print "$foot$copy\n";
		print "</body></html>\n";
	}
	exit;
}

#-----------------------------------------------------------
#  ݎǗ
#-----------------------------------------------------------
sub member {
	my $job = shift;

	# /IP擾
	my $now = time;
	my $addr = $ENV{REMOTE_ADDR};

	my ($i,$member,$flg,@log);
	open(DAT,"+< $cf{memfile}") or &error("open err: $cf{memfile}");
	eval "flock(DAT, 2);";
	while(<DAT>) {
		my ($time,$name,$ip) = split(/<>/);

		# 60bȏ㔭̂Ȃ҂͍폜
		if ($now - 60 > $time) {
			$flg = 1;
			next;
		}

		if ($addr eq $ip) {
			$flg = 2;

			# ގҍ폜
			if ($job eq 'out') {
				next;

			# /OXV
			} else {
				$name = $in{name};
				$_ = "$now<>$name<>$addr<>\n";
			}
		}
		# XVpzɒǉ
		push(@log,$_);

		# Qҕ\p쐬
		if ($i % 2) {
			$member .= "$name";
			$i++;
		} else {
			$member .= "$name";
			$i++;
		}
	}
	# VKQҒǉ
	if (!$flg && $job ne 'out' && $in{name} ne '') {
		$flg = 3;
		push(@log,"$now<>$in{name}<>$addr<>\n");
		$member = $i % 2 ? "$member$in{name}" : "$member$in{name}";
	}

	# QҐ
	my $num = @log;

	# t@CXV
	if ($job || $flg) {
		seek(DAT, 0, 0);
		print DAT @log;
		truncate(DAT, tell(DAT));
	}
	close(DAT);

	return ($num,$member);
}

#-----------------------------------------------------------
#  NbL[s
#-----------------------------------------------------------
sub set_cookie {
	my @data = @_;

	my ($sec,$min,$hour,$mday,$mon,$year,$wday,undef,undef) = gmtime(time + 60*24*60*60);
	my @mon  = qw|Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec|;
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# tH[}bg
	my $gmt = sprintf("%s, %02d-%s-%04d %02d:%02d:%02d GMT",
				$week[$wday],$mday,$mon[$mon],$year+1900,$hour,$min,$sec);

	# URLGR[h
	my $cook;
	foreach (@data) {
		s/(\W)/sprintf("%%%02X", unpack("C", $1))/eg;
		$cook .= "$_<>";
	}

	print "Set-Cookie: fox_chat=$cook; expires=$gmt\n";
}

#-----------------------------------------------------------
#  NbL[擾
#-----------------------------------------------------------
sub get_cookie {
	# NbL[擾
	my $cook = $ENV{HTTP_COOKIE};

	# YIDo
	my %cook;
	foreach ( split(/;/, $cook) ) {
		my ($key,$val) = split(/=/);
		$key =~ s/\s//g;
		$cook{$key} = $val;
	}

	# URLfR[h
	my @cook;
	foreach ( split(/<>/, $cook{fox_chat}) ) {
		s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("H2", $1)/eg;
		s/[&"'<>]//g;

		push(@cook,$_);
	}
	return @cook;
}

#-----------------------------------------------------------
#  zXg擾
#-----------------------------------------------------------
sub get_host {
	# IP/zXg擾
	my $host = $ENV{REMOTE_HOST};
	my $addr = $ENV{REMOTE_ADDR};

	if ($cf{gethostbyaddr} && ($host eq "" || $host eq $addr)) {
		$host = gethostbyaddr(pack("C4", split(/\./, $addr)), 2);
	}
	$host ||= $addr;
	return $host;
}

#-----------------------------------------------------------
#  Ԏ擾
#-----------------------------------------------------------
sub get_time {
	$ENV{TZ} = "JST-9";
	my $time = time;
	my ($min,$hour,$mday,$mon,$year,$wday) = (localtime($time))[1..6];
	my @week = qw|Sun Mon Tue Wed Thu Fri Sat|;

	# ̃tH[}bg
	my $date = sprintf("%04d/%02d/%02d(%s) %02d:%02d",
			$year+1900,$mon+1,$mday,$week[$wday],$hour,$min);

	return ($date, $time);
}

#-----------------------------------------------------------
#  URLGR[h
#-----------------------------------------------------------
sub url_encode {
	my $str = shift;

	$str =~ s/([^\w ])/'%'.unpack('H2', $1)/eg;
	$str =~ tr/ /+/;
	return $str;
}

#-----------------------------------------------------------
#  G[
#-----------------------------------------------------------
sub error {
	my $err = shift;

	open(IN,"$cf{tmpldir}/error.html") or die;
	my $tmpl = join('', <IN>);
	close(IN);

	$tmpl =~ s/!error!/$err/g;
	$tmpl =~ s|!bbs_css!|$cf{cmnurl}/windy.css|g;
	$tmpl =~ s/!chat_title!/$cf{chat_title}/g;

	print "Content-type: text/html\n\n";
	print $tmpl;
	exit;
}

